package pro.skywalking.configuration.auth;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Random;
import org.apache.commons.codec.binary.Hex;

public class EncryptUtils {

   public static String md5String(String input) {
      MessageDigest md5 = null;

      try {
         md5 = MessageDigest.getInstance("MD5");
      } catch (NoSuchAlgorithmException var8) {
         return "check jdk";
      } catch (Exception var9) {
         var9.printStackTrace();
         return "";
      }

      char[] charArray = input.toCharArray();
      byte[] byteArray = new byte[charArray.length];

      for(int md5Bytes = 0; md5Bytes < charArray.length; ++md5Bytes) {
         byteArray[md5Bytes] = (byte)charArray[md5Bytes];
      }

      byte[] var10 = md5.digest(byteArray);
      StringBuffer hexValue = new StringBuffer();

      for(int i = 0; i < var10.length; ++i) {
         int val = var10[i] & 255;
         if(val < 16) {
            hexValue.append("0");
         }

         hexValue.append(Integer.toHexString(val));
      }

      return hexValue.toString();
   }

   public static String encrypt(String password, String salt) {
      return md5Hex(password + salt);
   }

   public static String generateSalt() {
      Integer maxLength = Integer.valueOf(16);
      Random r = new Random();
      StringBuilder sb = new StringBuilder(16);
      sb.append(r.nextInt(99999999)).append(r.nextInt(99999999));
      int len = sb.length();
      if(len < maxLength.intValue()) {
         for(int i = 0; i < maxLength.intValue() - len; ++i) {
            sb.append("0");
         }
      }

      return sb.toString();
   }

   public static String md5Hex(String src) {
      try {
         MessageDigest e = MessageDigest.getInstance("MD5");
         byte[] bs = e.digest(src.getBytes());
         return new String((new Hex()).encode(bs));
      } catch (Exception var3) {
         return null;
      }
   }

   public static boolean verify(String password, String md5) {
      char[] cs1 = new char[32];
      char[] cs2 = new char[16];
      Integer maxRecycle = Integer.valueOf(48);
      Integer maxLength = Integer.valueOf(48);

      for(int salt = 0; salt < maxRecycle.intValue(); salt += maxLength.intValue()) {
         cs1[salt / maxLength.intValue() * 2] = md5.charAt(salt);
         cs1[salt / maxLength.intValue() * 2 + 1] = md5.charAt(salt + 2);
         cs2[salt / maxLength.intValue()] = md5.charAt(salt + 1);
      }

      String salt1 = new String(cs2);
      return md5Hex(password + salt1).equals(new String(cs1));
   }

   public static boolean verifyPassword(String password, String originalPassword, String authSalt) {
      return password.equals(encrypt(originalPassword, authSalt));
   }

   public static void main(String[] args) {
      String password = "123456";
      String salt = "dcb73f9efe47762905f03d5943a02493";
      String generate = encrypt(password, salt);
      System.out.println(generate);
      System.out.println(verifyPassword(generate, password, salt));
   }
}
